import RPi.GPIO as GPIO
import time
import os
##from PIL import Image

GPIO.setmode(GPIO.BOARD)

PIN_TRIGGER = 7
PIN_ECHO = 11

PIN_LED_ROT = 15

GPIO.setup(PIN_TRIGGER, GPIO.OUT)
GPIO.setup(PIN_ECHO, GPIO.IN)

GPIO.setup(PIN_LED_ROT, GPIO.OUT)

delayBetweenCars = 3

lastAction = 0;

distanceMin = 0
distanceMax = 1000

lastImage = ''
##new_image = Image.new('RGB', (1920, 1080))

imageWidth = 1920
imageHeight = 1080

def current_milli_time():
   return round(time.time() * 1000)

def takePicture():
   global lastImage, imageWidth, imageHeight
   lastImage = './images/'+str(current_milli_time())+'.jpg' 
   os.system('fswebcam -r '+str(imageWidth)+'x'+str(imageHeight)+' --no-banner ' + lastImage)

def copy_image(image, offset_x=0, offset_y=0):
    global new_image, imageWidth, imageHeight
    # kopieren der einzelnen Pixelinformationen in das neue Bild
    for i in range(0, imageHeight, imageWidth):
        im = Image.open(image)
        new_image.paste(im, (i + offset_x, offset_y))


def mergeBorderWithImage():
   global lastImage, new_image, imageWidth, imageHeight
   print("drin")
   print(lastImage)
   background = './images/rahmen.png'
   new_image = Image.new('RGB', (imageWidth, imageHeight))
   copy_image(background)
   copy_image(lastImage)
   new_image.save('output_'+str(current_milli_time())+'.jpg')

try:
        while True:
                GPIO.output(PIN_LED_ROT, GPIO.LOW)

                GPIO.output(PIN_TRIGGER, GPIO.LOW)
                time.sleep(0.5)
                GPIO.output(PIN_TRIGGER, GPIO.HIGH)
                time.sleep(0.00001)
                GPIO.output(PIN_TRIGGER, GPIO.LOW)
                while GPIO.input(PIN_ECHO)==0:
                        pulse_start_time = time.time()
                while GPIO.input(PIN_ECHO)==1:
                        pulse_end_time = time.time()
                pulse_duration = pulse_end_time - pulse_start_time
                distance = round(pulse_duration * 17150, 2)
                print("Distanz: %.1f" % distance,"cm")

                millis = lastAction + delayBetweenCars

                if(distance > distanceMin and distance < distanceMax):
                        GPIO.output(PIN_LED_ROT, GPIO.HIGH)
                        takePicture()
                        #mergeBorderWithImage()
                        time.sleep(0.25)
                        GPIO.output(PIN_LED_ROT, GPIO.LOW)
                        time.sleep(delayBetweenCars)
                else:
                        GPIO.output(PIN_LED_ROT, GPIO.LOW)

                time.sleep(1)
finally:
      GPIO.cleanup()
